'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Stylesheet = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.css = css;

var _index = require('./index.js');

var glamor = _interopRequireWildcard(_index);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var Stylesheet = exports.Stylesheet = {
  create: function create(spec) {

    var entries = Object.keys(spec).map(function (name) {
      var _style = {},
          _rules = [];
      Object.keys(spec[name]).forEach(function (key) {

        if (key.charAt(0) === ':') {
          if (key.charAt(1) === ':') {
            _rules.push(glamor[key.slice(2)](spec[key]));
          } else {
            _rules.push(glamor[key.slice(1)](spec[key]));
          }
          // todo - parameterized pseudos           
        }
        if (/^\@media/.exec(key)) {
          _rules.push(glamor.media(key.substring(6, key.indexOf('{') - 1)));
        } else {
          _style[key] = spec[name][key];
        }
      });
      return [name, glamor.idFor(glamor.merge.apply(glamor, [_style].concat(_rules)))];
    });

    return entries.reduce(function (o, _ref) {
      var _ref2 = _slicedToArray(_ref, 2);

      var name = _ref2[0];
      var val = _ref2[1];
      return o[name] = val, o;
    }, {});
  }
};

function css() {
  for (var _len = arguments.length, rules = Array(_len), _key = 0; _key < _len; _key++) {
    rules[_key] = arguments[_key];
  }

  return rules.filter(function (x) {
    return !!x;
  }).join(' ');
  // return just data-css-<id> string. we then expect createElement to catch it and transform into attribs 
}

// todo - animations 
// fonts